# (c) 2018-2024 MPIB <https://www.mpib-berlin.mpg.de/>,
#     2018-2019 MPI-CBS <https://www.cbs.mpg.de/>,
#     2018-2019 MPIP <http://www.psych.mpg.de/>
#
# This file is part of Castellum.
#
# Castellum is free software; you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# Castellum is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with Castellum. If not, see
# <http://www.gnu.org/licenses/>.

import datetime

from django.conf import settings

from .models import AuditEvent


def cleanup(dt=datetime.timedelta(days=365)):
    threshold = datetime.date.today() - dt
    AuditEvent.objects.filter(created_at__lt=threshold).delete()


def audit(action, username, *, study_pk=None, subject_pk=None, extra=None):
    if settings.CASTELLUM_AUDIT_TRAIL_ENABLED:
        cleanup()
        AuditEvent.objects.create(
            action=action,
            username=username or 'anon',
            study_pk=study_pk,
            subject_pk=subject_pk,
            extra=extra,
        )
